(** File generated by coq-of-ocaml *)
Require Import CoqOfOCaml.CoqOfOCaml.
Require Import CoqOfOCaml.Settings.

Require Import TezosOfOCaml.Proto_alpha.Environment.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_message_repr.

Definition hash_size : int := 32.

Definition Inbox_hash :=
  Blake2B.Make
    {|
      Blake2B.Register.register_encoding _ := Base58.register_encoding
    |}
    (let name := "Tx_rollup_inbox_hash" in
    let title := "The hash of a transaction rollup inbox" in
    let b58check_prefix := "\004\200" in
    let size_value := Some hash_size in
    {|
      Blake2B.PrefixedName.name := name;
      Blake2B.PrefixedName.title := title;
      Blake2B.PrefixedName.size_value := size_value;
      Blake2B.PrefixedName.b58check_prefix := b58check_prefix
    |}).

(** Init function; without side-effects in Coq *)
Definition init_module_repr : unit :=
  Base58.check_encoded_prefix Inbox_hash.(S.HASH.b58check_encoding) "i" 51.

Definition hash : Set := Inbox_hash.(S.HASH.t).

Definition compare_hash
  : Inbox_hash.(S.HASH.t) -> Inbox_hash.(S.HASH.t) -> int :=
  Inbox_hash.(S.HASH.compare).

Definition equal_hash
  : Inbox_hash.(S.HASH.t) -> Inbox_hash.(S.HASH.t) -> bool :=
  Inbox_hash.(S.HASH.equal).

Definition pp_hash : Format.formatter -> Inbox_hash.(S.HASH.t) -> unit :=
  Inbox_hash.(S.HASH.pp).

Definition hash_of_bytes_exn : bytes -> Inbox_hash.(S.HASH.t) :=
  Inbox_hash.(S.HASH.of_bytes_exn).

Definition hash_of_bytes_opt : bytes -> option Inbox_hash.(S.HASH.t) :=
  Inbox_hash.(S.HASH.of_bytes_opt).

Definition hash_of_b58check_exn : string -> Inbox_hash.(S.HASH.t) :=
  Inbox_hash.(S.HASH.of_b58check_exn).

Definition hash_of_b58check_opt : string -> option Inbox_hash.(S.HASH.t) :=
  Inbox_hash.(S.HASH.of_b58check_opt).

Definition hash_encoding : Data_encoding.t Inbox_hash.(S.HASH.t) :=
  Inbox_hash.(S.HASH.encoding).

Definition hash_to_bytes : Inbox_hash.(S.HASH.t) -> bytes :=
  Inbox_hash.(S.HASH.to_bytes).

Definition hash_to_b58check : Inbox_hash.(S.HASH.t) -> string :=
  Inbox_hash.(S.HASH.to_b58check).

Definition extend_hash
  (inbox_hash : Inbox_hash.(S.HASH.t)) (msg_hash : Tx_rollup_message_repr.hash)
  : Inbox_hash.(S.HASH.t) :=
  let inbox_hash :=
    Data_encoding.Binary.to_bytes_exn None hash_encoding inbox_hash in
  let msg_hash :=
    Data_encoding.Binary.to_bytes_exn None Tx_rollup_message_repr.hash_encoding
      msg_hash in
  Inbox_hash.(S.HASH.hash_bytes) None [ inbox_hash; msg_hash ].

Definition hash_hashed_inbox (message_hashes : list Tx_rollup_message_repr.hash)
  : Inbox_hash.(S.HASH.t) :=
  List.fold_left extend_hash
    (Inbox_hash.(S.HASH.hash_bytes) None [ Bytes.make hash_size (Char.chr 0) ])
    message_hashes.

Definition hash_inbox (messages : list Tx_rollup_message_repr.t)
  : Inbox_hash.(S.HASH.t) :=
  let message_hashes :=
    List.map Tx_rollup_message_repr.hash_uncarbonated messages in
  hash_hashed_inbox message_hashes.

Module t.
  Record record : Set := Build {
    contents : list Tx_rollup_message_repr.hash;
    cumulated_size : int;
    hash : hash }.
  Definition with_contents contents (r : record) :=
    Build contents r.(cumulated_size) r.(hash).
  Definition with_cumulated_size cumulated_size (r : record) :=
    Build r.(contents) cumulated_size r.(hash).
  Definition with_hash hash (r : record) :=
    Build r.(contents) r.(cumulated_size) hash.
End t.
Definition t := t.record.

Definition pp (fmt : Format.formatter) (function_parameter : t) : unit :=
  let '{|
    t.contents := contents;
      t.cumulated_size := cumulated_size;
      t.hash := hash_value
      |} := function_parameter in
  Format.fprintf fmt
    (CamlinternalFormatBasics.Format
      (CamlinternalFormatBasics.String_literal "tx rollup inbox: "
        (CamlinternalFormatBasics.Int CamlinternalFormatBasics.Int_d
          CamlinternalFormatBasics.No_padding
          CamlinternalFormatBasics.No_precision
          (CamlinternalFormatBasics.String_literal " messages using "
            (CamlinternalFormatBasics.Int CamlinternalFormatBasics.Int_d
              CamlinternalFormatBasics.No_padding
              CamlinternalFormatBasics.No_precision
              (CamlinternalFormatBasics.String_literal " bytes with hash "
                (CamlinternalFormatBasics.Alpha
                  CamlinternalFormatBasics.End_of_format))))))
      "tx rollup inbox: %d messages using %d bytes with hash %a")
    (List.length contents) cumulated_size pp_hash hash_value.

Definition encoding : Data_encoding.encoding t :=
  Data_encoding.conv
    (fun (function_parameter : t) =>
      let '{|
        t.contents := contents;
          t.cumulated_size := cumulated_size;
          t.hash := hash_value
          |} := function_parameter in
      (contents, cumulated_size, hash_value))
    (fun (function_parameter : list Tx_rollup_message_repr.hash * int * hash) =>
      let '(contents, cumulated_size, hash_value) := function_parameter in
      {| t.contents := contents; t.cumulated_size := cumulated_size;
        t.hash := hash_value |}) None
    (Data_encoding.obj3
      (Data_encoding.req None None "contents"
        (Data_encoding.list_value None Tx_rollup_message_repr.hash_encoding))
      (Data_encoding.req None None "cumulated_size" Data_encoding.int31)
      (Data_encoding.req None None "hash" hash_encoding)).

Module metadata.
  Record record : Set := Build {
    inbox_length : int32;
    cumulated_size : int;
    hash : hash }.
  Definition with_inbox_length inbox_length (r : record) :=
    Build inbox_length r.(cumulated_size) r.(hash).
  Definition with_cumulated_size cumulated_size (r : record) :=
    Build r.(inbox_length) cumulated_size r.(hash).
  Definition with_hash hash (r : record) :=
    Build r.(inbox_length) r.(cumulated_size) hash.
End metadata.
Definition metadata := metadata.record.

Definition metadata_encoding : Data_encoding.encoding metadata :=
  Data_encoding.conv
    (fun (function_parameter : metadata) =>
      let '{|
        metadata.inbox_length := inbox_length;
          metadata.cumulated_size := cumulated_size;
          metadata.hash := hash_value
          |} := function_parameter in
      (inbox_length, cumulated_size, hash_value))
    (fun (function_parameter : int32 * int * hash) =>
      let '(inbox_length, cumulated_size, hash_value) := function_parameter in
      {| metadata.inbox_length := inbox_length;
        metadata.cumulated_size := cumulated_size; metadata.hash := hash_value
        |}) None
    (Data_encoding.obj3
      (Data_encoding.req None None "inbox_length" Data_encoding.int32_value)
      (Data_encoding.req None None "cumulated_size" Data_encoding.int31)
      (Data_encoding.req None None "hash" hash_encoding)).

Definition empty_metadata : metadata :=
  {| metadata.inbox_length := 0; metadata.cumulated_size := 0;
    metadata.hash :=
      Inbox_hash.(S.HASH.hash_bytes) None [ Bytes.make hash_size (Char.chr 0) ]
    |}.
